"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require("@angular/forms");
var select_1 = require('./../common/select');
var SelectComponent = (function (_super) {
    __extends(SelectComponent, _super);
    function SelectComponent(elementRef, zone) {
        _super.call(this, elementRef, zone);
        this.elementRef = elementRef;
        this.zone = zone;
        this.placeholder = 'Selecione';
        this.resultadoCompleto = false;
        this.indiceId = 'id';
        this.indiceNome = 'nome';
        this.change = new core_1.EventEmitter();
    }
    Object.defineProperty(SelectComponent.prototype, "valores", {
        set: function (valor) {
            this._valores = valor;
            this.valoresExibir = valor;
        },
        enumerable: true,
        configurable: true
    });
    SelectComponent.prototype.abrir = function () {
        this.aberto = !this.aberto;
        if (this.aberto) {
            this.campoBusca.nativeElement.focus();
            this.setFocus(true);
            this.buscar('');
        }
    };
    SelectComponent.prototype.selecionar = function (item) {
        this.data = item;
        this.updateValue(this.data);
        this.fechar();
        //apaga campo de busca
        this.campoBusca.nativeElement.value = '';
    };
    SelectComponent.prototype.limpar = function () {
        this.data = null;
        this.updateValue(null);
        this.aberto = true;
    };
    SelectComponent.prototype.remove = function (item) {
        this.removePorResultadoCompleto(item);
    };
    SelectComponent.prototype.buscar = function (valor) {
        var _this = this;
        this.valorPesquisado = valor;
        this.valoresExibir = this._valores.filter(function (item) { return item[_this.indiceNome].indexOf(_this.valorPesquisado) !== -1; });
    };
    Object.defineProperty(SelectComponent.prototype, "value", {
        get: function () { return this._value; },
        set: function (v) {
            if (v !== this._value) {
                this._value = v;
                this._onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    SelectComponent.prototype.writeValue = function (value) {
        this.data = value;
        this._value = value;
    };
    SelectComponent.prototype.updateValue = function (value) {
        var _this = this;
        this.zone.run(function () {
            _this._value = value;
            _this.onChange(value);
            _this._onTouchedCallback();
            _this.change.emit(value);
        });
    };
    SelectComponent.prototype.onChange = function (_) { };
    SelectComponent.prototype.onTouched = function () { };
    SelectComponent.prototype.registerOnChange = function (fn) { this.onChange = fn; };
    SelectComponent.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
    SelectComponent.prototype._onChangeCallback = function (_) { };
    SelectComponent.prototype._onTouchedCallback = function () { };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], SelectComponent.prototype, "name", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], SelectComponent.prototype, "classe", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], SelectComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', core_1.TemplateRef)
    ], SelectComponent.prototype, "templateResultado", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', core_1.TemplateRef)
    ], SelectComponent.prototype, "templateSelecionado", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', core_1.TemplateRef)
    ], SelectComponent.prototype, "templateSemResultado", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], SelectComponent.prototype, "resultadoCompleto", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], SelectComponent.prototype, "indiceId", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], SelectComponent.prototype, "indiceNome", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], SelectComponent.prototype, "valores", null);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], SelectComponent.prototype, "change", void 0);
    __decorate([
        core_1.ViewChild('campoBusca'), 
        __metadata('design:type', core_1.ElementRef)
    ], SelectComponent.prototype, "campoBusca", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], SelectComponent.prototype, "value", null);
    SelectComponent = __decorate([
        core_1.Component({
            selector: 'select2-select',
            templateUrl: './../view/select.component.html',
            providers: [
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return SelectComponent; }),
                    multi: true
                }
            ],
            host: {
                '(document:click)': 'clickForaComponent($event)',
                '(focus)': 'setFocus(true)',
                '(blur)': 'setFocus(false)',
            },
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.NgZone])
    ], SelectComponent);
    return SelectComponent;
}(select_1.Select));
exports.SelectComponent = SelectComponent;
//# sourceMappingURL=select.component.js.map